#----------------Z_TEST--------------------------------------------------------------------
def Two_sample_ztest_two_tail(x1bar,sigma1,n1,x2bar,sigma2,n2,a):
  import math
  import scipy.stats
  z_cal=round((x1bar-x2bar)/(math.sqrt(sigma1*sigma1/n1+sigma2*sigma2/n2)),4)
  z=abs(round(scipy.stats.norm.ppf(a/2),4))
  p=round(2*(1-scipy.stats.norm.cdf(abs(z_cal))),4)
  print(f"here we have given following information")
  print(f"x1bar={x1bar},sigma1={sigma1},n1={n1},x2bar={x2bar},sigma2={sigma2},n2={n2},alpha={a}")
  print(" ")
  print("Null and alternative:")
  print(f"Ho:mue1=mue2")
  print(f"H1:mue1≠mue2")
  print(" ")
  print("Test statistics:")
  print("z_cal=(x1bar-x2bar)/(sqrt(sigma1^2/n1+sigma2^2/n2))")
  print(f"z_cal=({x1bar}-{x2bar})/(sqrt({round(sigma1*sigma1,4)}/{n1} + {round(sigma2*sigma2,4)}/{n2}))={z_cal}")
  print(" ")
  print("Cirtical value and Pvalue:")
  print(f"z_c={z} is critical value ")
  print(f"P={p} is p value of test statistic  ")
  print(f"Note: Excel command for z_c is  =abs(NORMSINV({a/2}))")
  print(f"      and for Pvalue is  =2*(1-NORMSDIST(abs({z_cal})))")
  print(" ")
  print("Decision:")
  print("1]Based on cirtical value approch-")
  if p>a:
        print(f"here |z_cal| <= z_c so do not reject null hypothesis")
  else: 
        print(f"here |z_cal| > z_c so reject null hypothesis")
        
  print("")
 
  print("2]Based on P- value approch-")
  if p>a:
        print(f"here Pvalue >= alpha so do not reject null hypothesis")
  else: 
        print(f"here Pvalue < alpha  so reject null hypothesis")
  print("")
  print("Conclusion:")
  if p>a:
        print(f"Ho:mue1=mue2")
  else:
        print(f"Ho:mue1≠mue2")
  
  
def  Two_sample_ztest_right_tail(x1bar,sigma1,n1,x2bar,sigma2,n2,a):
  import math
  import scipy.stats
  z_cal=round((x1bar-x2bar)/(math.sqrt(sigma1*sigma1/n1+sigma2*sigma2/n2)),4)
  z=abs(round(scipy.stats.norm.ppf(a),4))
  p=round(1-scipy.stats.norm.cdf((z_cal)),4)
  print(f"here we have given following information")
  print(f"x1bar={x1bar},sigma1={sigma1},n1={n1},x2bar={x2bar},sigma2={sigma2},n2={n2},alpha={a}")
  print(" ")
  print("Null and alternative:")
  print(f"Ho:mue1=mue2")
  print(f"H1:mue1>mue2")
  print(" ")
  print("Test statistics:")
  print("z_cal=(x1bar-x2bar)/(math.sqrt(sigma1^2/n1+sigma2^2/n2))")
  print(f"z_cal=({x1bar}-{x2bar})/(math.sqrt({round(sigma1*sigma1,4)}/{n1} + {round(sigma2*sigma2,4)}/{n2}))={z_cal}")
  print(" ")
  print("Cirtical value and Pvalue:")
  print(f"z_c={z} is critical value ")
  print(f"P={p} is p value of test statistic  ")
  print(f"Note: Excel command for z_c is  =-NORMSINV({a})")
  print(f"      and for Pvalue is  =1-NORMSDIST({z_cal})")
  print(" ")
  print("Decision:")
  print("1]Based on cirtical value approch-")
  if p>a:
        print(f"here z_cal <= z_c so do not reject null hypothesis")
  else: 
        print(f"here z_cal > z_c so reject null hypothesis")
        
  print("")
 
  print("2]Based on P- value approch-")
  if p>a:
        print(f"here Pvalue >= alpha so do not reject null hypothesis")
  else: 
        print(f"here Pvalue < alpha  so reject null hypothesis")
  print("")
  print("Conclusion:")
  if p>a:
        print(f"Ho:mue1=mue2")
  else:
        print(f"Ho:mue1>mue2")
  
def Two_sample_ztest_left_tail(x1bar,sigma1,n1,x2bar,sigma2,n2,a):
  import math
  import scipy.stats
  z_cal=round((x1bar-x2bar)/(math.sqrt(sigma1*sigma1/n1+sigma2*sigma2/n2)),4)
  z=abs(round(scipy.stats.norm.ppf(a),4))
  p=round(1-scipy.stats.norm.cdf((z_cal)),4)
  print(f"here we have given following information")
  print(f"x1bar={x1bar},sigma1={sigma1},n1={n1},x2bar={x2bar},sigma2={sigma2},n2={n2},alpha={a}")
  print(" ")
  print("Null and alternative:")
  print(f"Ho:mue1=mue2")
  print(f"H1:mue1<mue2")
  print(" ")
  print("Test statistics:")
  print("z_cal=(x1bar-x2bar)/(math.sqrt(sigma1^2/n1+sigma2^2/n2))")
  print(f"z_cal=({x1bar}-{x2bar})/(math.sqrt({round(sigma1*sigma1,4)}/{n1} + {round(sigma2*sigma2,4)}/{n2}))={z_cal}")
  print(" ")
  print("Cirtical value and Pvalue:")
  print(f"z_c={-z} is critical value ")
  print(f"P={p} is p value of test statistic  ")
  print(f"Note: Excel command for z_c is  =NORMSINV({a})")
  print(f"      and for Pvalue is  =NORMSDIST({z_cal})")
  print(" ")
  print("Decision:")
  print("1]Based on cirtical value approch-")
  if p>a:
        print(f"here z_cal >= z_c so do not reject null hypothesis")
  else: 
        print(f"here z_cal < z_c so reject null hypothesis")
        
  print("")
 
  print("2]Based on P- value approch-")
  if p>a:
        print(f"here Pvalue >= alpha so do not reject null hypothesis")
  else: 
        print(f"here Pvalue < alpha  so reject null hypothesis")
  print("")
  print("Conclusion:")
  if p>a:
        print(f"Ho:mue1=mue2")
  else:
        print(f"H1:mue1<mue2")

def  One_sample_ztest_two_tail(mue,xbar,sd,n,a):
 import math
 import scipy.stats
 z_cal=round((xbar-mue)/(sd/math.sqrt(n)),4)
 z=abs(round(scipy.stats.norm.ppf(a/2),4))
 p=round(2*(1-scipy.stats.norm.cdf(abs(z_cal))),4)
 print(f"here we have given following information")
 print(f"xbar={xbar}; sd={sd}; n={n}; alpha={a}")
 print(" ")
 print("Null and alternative:")
 print(f"Ho:mue={mue}")
 print(f"H1:mue≠{mue}")
 print(" ")
 print("Test statistics:")
 print("z_cal=(xbar-mue)/(sd/sqrt(n))")
 print(f"z_cal=({xbar}-{mue})/({sd}/sqrt({n}))={z_cal}")
 print(" ")
 print("Cirtical value and Pvalue:")
 print(f"z_c={z} is critical value ")
 print(f"P={p} is p value of test statistic  ")
 print(f"Note: Excel command for z_c is  =abs(NORMSINV({a/2}))")
 print(f"      and for Pvalue is  =2*(1-NORMSDIST(abs({z_cal})))")
 print(" ")
 print("Decision:")
 print("1]Based on cirtical value approch-")
 if p>a:
        print(f"here |z_cal| <= z_c so do not reject null hypothesis")
 else: 
        print(f"here |z_cal| > z_c so reject null hypothesis")
        
 print("")
 
 print("2]Based on P- value approch-")
 if p>a:
        print(f"here Pvalue >= alpha so do not reject null hypothesis")
 else: 
        print(f"here Pvalue < alpha  so reject null hypothesis")
 print("")
 print("Conclusion:")
 if p>a:
        print(f"mue={mue}")
 else:
        print(f"mue≠{mue}")


def  One_sample_ztest_right_tail(mue,xbar,sd,n,a):
 import math
 import scipy.stats
 z_cal=round((xbar-mue)/(sd/math.sqrt(n)),4)
 z=abs(round(scipy.stats.norm.ppf(a),4))
 p=round((1-scipy.stats.norm.cdf((z_cal))),4)
 print(f"here we have given following information")
 print(f"xbar={xbar}; sd={sd}; n={n}; alpha={a}")
 print(" ")
 print("Null and alternative:")
 print(f"Ho:mue={mue}")
 print(f"H1:mue>{mue}")
 print(" ")
 print("Test statistics:")
 print("z_cal=(xbar-mue)/(sd/sqrt(n))")
 print(f"z_cal=({xbar}-{mue})/({sd}/sqrt({n}))={z_cal}")
 print(" ")
 print("Cirtical value and Pvalue:")
 print(f"z_c={z} is critical value ")
 print(f"P={p} is p value of test statistic  ")
 print(f"Note: Excel command for z_c is  =NORMSINV({a})")
 print(f"      and for Pvalue is  =1-NORMSDIST({z_cal})")
 print(" ")
 print("Decision:")
 print("1]Based on cirtical value approch-")
 if p>a:
        print(f"here z_cal <= z_c so do not reject null hypothesis")
 else: 
        print(f"here z_cal > z_c so reject null hypothesis")
        
 print("")
 
 print("2]Based on P- value approch-")
 if p>a:
        print(f"here Pvalue >= alpha so do not reject null hypothesis")
 else: 
        print(f"here Pvalue < alpha  so reject null hypothesis")
 print("")
 print("Conclusion:")
 if p>a:
        print(f"mue={mue}")
 else:
        print(f"mue>{mue}")
 
 
def One_sample_ztest_left_tail(mue,xbar,sd,n,a):
 import math
 import scipy.stats
 z_cal=round((xbar-mue)/(sd/math.sqrt(n)),4)
 z=abs(round(scipy.stats.norm.ppf(a),4))
 p=round(scipy.stats.norm.cdf((z_cal)),4)
 print(f"here we have given following information")
 print(f"xbar={xbar}; sd={sd}; n={n}; alpha={a}")
 print(" ")
 print("Null and alternative:")
 print(f"Ho:mue={mue}")
 print(f"H1:mue<{mue}")
 print(" ")
 print("Test statistics:")
 print("z_cal=(xbar-mue)/(sd/sqrt(n))")
 print(f"z_cal=({xbar}-{mue})/({sd}/sqrt({n}))={z_cal}")
 print(" ")
 print("Cirtical value and Pvalue:")
 print(f"z_c={-z} is critical value ")
 print(f"P={p} is p value of test statistic  ")
 print(f"Note: Excel command for z_c is  =NORMSINV({a})")
 print(f"      and for Pvalue is  =NORMSDIST({z_cal})")
 print(" ")
 print("Decision:")
 print("1]Based on cirtical value approch-")
 if p>a:
        print(f"here z_cal >= z_c so do not reject null hypothesis")
 else: 
        print(f"here z_cal < z_c so reject null hypothesis")
        
 print("")
 
 print("2]Based on P- value approch-")
 if p>a:
        print(f"here Pvalue >= alpha so do not reject null hypothesis")
 else: 
        print(f"here Pvalue < alpha  so reject null hypothesis")
 print("")
 print("Conclusion:")
 if p>a:
        print(f"mue={mue}")
 else:
        print(f"mue<{mue}")
